package org.openjdk.gcbench.retain;

import org.openjdk.jmh.annotations.*;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(Threads.MAX)
@State(Scope.Benchmark)
public class RefArray {

    Object retain;

    @Param({"100000"})
    private int size;

    @Setup
    public void setup() {
        Object[] arr = new Object[size];
        for (int c = 0; c < size; c++) {
            arr[c] = new Object();
        }
        retain = arr;
    }

    @Benchmark
    public Object test() {
        // allocation pressure to trigger GCs
        return new Object();
    }

}
